package eu.etaxonomy.taxeditor;

import java.util.ArrayList;
import java.util.List;

import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.cdm.api.service.*;
import eu.etaxonomy.cdm.api.application.CdmApplicationController;


public class SimpleModel {
	private ArrayList modelListeners;
	private ArrayList objects;
	public SimpleModel() {
		modelListeners = new ArrayList();
		initialize();
	}
	public void addModelListener(IModelListener listener) {
		if (!modelListeners.contains(listener))
			modelListeners.add(listener);
	}
	public void removeModelListener(IModelListener listener) {
		modelListeners.remove(listener);
	}
	public void fireModelChanged(Object[] objects, String type, String property) {
		for (int i = 0; i < modelListeners.size(); i++) {
			((IModelListener) modelListeners.get(i)).modelChanged(objects,
					type, property);
		}
	}
	public Object[] getContents() {
		return objects.toArray();
	}
	private void initialize() {
		try {
			//TODO Andreas
			List<TaxonName> tnList = new ArrayList<TaxonName>();
			TaxonName tn = new TaxonName();
			CdmApplicationController app = new CdmApplicationController();
			NameService ns = app.getNameService();
			tnList.add(ns.getTaxonNameById(1));
			tnList.add(ns.getTaxonNameById(4));
			tnList.add(ns.getTaxonNameById(28));

			objects = new ArrayList();
			NamedObject[] objects = {
					new Name(tnList.get(0).getName(), tnList.get(0).getGenus(),tnList.get(0).getInfraSpecificEpithet()),
					new Name(tnList.get(1).getName(), tnList.get(1).getGenus(),tnList.get(1).getInfraSpecificEpithet()),
					new Name(tnList.get(2).getName(), tnList.get(2).getGenus(),tnList.get(2).getInfraSpecificEpithet()),
					
					new Name("Pilosella piloselloides (Vill.) Sojk", "Pilosella", "piloselloides"),
					new Name("Pilosella pavichii (Heuff.) Arv.-Touv.", "Pilosella", "pavichii"), 
					new Name("Pilosella vahlii (Froel.) F. W. Schultz & Sch. Bip.", "Pilosella", "vahlii")  
					/*new TypeOne(Messages.getString("SimpleModel.t1_i1"), 2, true, Messages.getString("SimpleModel.text1")), //$NON-NLS-1$ //$NON-NLS-2$
					new TypeOne(Messages.getString("SimpleModel.t1_i2"), 1, false, Messages.getString("SimpleModel.text2")), //$NON-NLS-1$ //$NON-NLS-2$
					new TypeOne(Messages.getString("SimpleModel.t1_i3"), 3, true, Messages.getString("SimpleModel.text3")), //$NON-NLS-1$ //$NON-NLS-2$
					new TypeOne(Messages.getString("SimpleModel.t1_i4"), 0, false, Messages.getString("SimpleModel.text4")), //$NON-NLS-1$ //$NON-NLS-2$
					new TypeOne(Messages.getString("SimpleModel.t1_i5"), 1, true, Messages.getString("SimpleModel.text5")), //$NON-NLS-1$ //$NON-NLS-2$
					new TypeTwo(Messages.getString("SimpleModel.t2_i1"), false, true), //$NON-NLS-1$
					new TypeTwo(Messages.getString("SimpleModel.t2_i2"), true, false)*/
			}; //$NON-NLS-1$
			add(objects, false);
		} catch (RuntimeException e) {
			//logger.error("Error when initializing SimpleModel");
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	public void add(NamedObject[] objs, boolean notify) {
		for (int i = 0; i < objs.length; i++) {
			objects.add(objs[i]);
			objs[i].setModel(this);
		}
		if (notify)
			fireModelChanged(objs, IModelListener.ADDED, ""); //$NON-NLS-1$
	}
	
//	public void add(ArrayList<TaxonName> tns, boolean notify) {
//		for (int i = 0; i < tns.size(); i++) {
//			objects.add(tns.get(i));
//			//tns[i].setModel(this);
//		}
//		//if (notify)
//			//fireModelChanged(tns, IModelListener.ADDED, ""); //$NON-NLS-1$
//	}
		
	public void remove(NamedObject[] objs, boolean notify) {
		for (int i = 0; i < objs.length; i++) {
			objects.remove(objs[i]);
			objs[i].setModel(null);
		}
		if (notify)
			fireModelChanged(objs, IModelListener.REMOVED, ""); //$NON-NLS-1$
	}
}
